module Shift.Generate where

import CMarkGFM (nodeToCommonmark)
import Control.Monad.IO.Class (MonadIO (liftIO))
import qualified Data.Text.IO as TIO
import Shift.CLI (ShiftOptions (ShiftOptions))
import Shift.Git (renderToNode)

runGenerate :: Maybe FilePath -> ShiftOptions -> IO ()
runGenerate maybeOutputPath opts = do
  node <- renderToNode opts

  let output = nodeToCommonmark [] Nothing node

  case maybeOutputPath of
    Just outputPath -> liftIO $ TIO.writeFile outputPath output
    Nothing -> liftIO $ TIO.putStr $ output